package ru.kfu.itis;

import java.io.*;
import java.net.Socket;
import java.util.Scanner;

import static java.lang.System.exit;

public final class Client {
    private static PrintWriter _out;
    private static BufferedReader _in;

    public static void main(String[] args) {
        if (args.length <2) {
            printInfo();
            exit(0);
        }

        System.out.println("Connecting to "+args[0]+":"+args[1]+"\n");

        try (
                Socket s = new Socket(args[0], Integer.parseInt(args[1]));
                BufferedReader in = new BufferedReader(new InputStreamReader(s.getInputStream()));
                PrintWriter out = new PrintWriter(s.getOutputStream(), true);
            ){
            _in = in;
            _out = out;
            System.out.println("Starting the game...\n\n");

            gameLoop();

        } catch (Exception e) {
            System.out.println("Client: exception: " + e);
        }
    }

    private static void readServerReply() {
        try {
                System.out.println(_in.readLine());

        } catch (IOException ioe) {
            System.out.println("Client: failed while reading server reply: " + ioe);
        }
    }

    private static void gameLoop() {
        String line;
        Scanner scanner = new Scanner(System.in);
            do {
                readServerReply();
                System.out.print("Enter a town: ");
                line = scanner.nextLine();
                sendMessage(line);
            } while (!ServerClientConstants.BYE.equals(line));
            sendMessage(ServerClientConstants.BYE);
            readServerReply();
    }
    private static void sendMessage(String str){
        _out.println(str);
    }

    private static void printInfo() {
        System.out.println("\n Usage:\n\n java Client.class words-game-server port");
    }
}